<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/cobs-0.2.3/src/dec.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>dec.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../cobs/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../cobs/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../cobs/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
<span id="285">285</span>
<span id="286">286</span>
<span id="287">287</span>
<span id="288">288</span>
<span id="289">289</span>
<span id="290">290</span>
<span id="291">291</span>
<span id="292">292</span>
<span id="293">293</span>
<span id="294">294</span>
<span id="295">295</span>
<span id="296">296</span>
<span id="297">297</span>
<span id="298">298</span>
<span id="299">299</span>
<span id="300">300</span>
<span id="301">301</span>
<span id="302">302</span>
<span id="303">303</span>
<span id="304">304</span>
<span id="305">305</span>
<span id="306">306</span>
<span id="307">307</span>
<span id="308">308</span>
<span id="309">309</span>
<span id="310">310</span>
<span id="311">311</span>
<span id="312">312</span>
<span id="313">313</span>
<span id="314">314</span>
<span id="315">315</span>
<span id="316">316</span>
<span id="317">317</span>
<span id="318">318</span>
<span id="319">319</span>
<span id="320">320</span>
<span id="321">321</span>
<span id="322">322</span>
<span id="323">323</span>
<span id="324">324</span>
<span id="325">325</span>
<span id="326">326</span>
<span id="327">327</span>
<span id="328">328</span>
<span id="329">329</span>
<span id="330">330</span>
<span id="331">331</span>
<span id="332">332</span>
<span id="333">333</span>
<span id="334">334</span>
<span id="335">335</span>
<span id="336">336</span>
<span id="337">337</span>
<span id="338">338</span>
<span id="339">339</span>
<span id="340">340</span>
<span id="341">341</span>
<span id="342">342</span>
<span id="343">343</span>
<span id="344">344</span>
<span id="345">345</span>
<span id="346">346</span>
<span id="347">347</span>
<span id="348">348</span>
<span id="349">349</span>
<span id="350">350</span>
<span id="351">351</span>
<span id="352">352</span>
<span id="353">353</span>
<span id="354">354</span>
<span id="355">355</span>
<span id="356">356</span>
<span id="357">357</span>
<span id="358">358</span>
<span id="359">359</span>
<span id="360">360</span>
</pre><pre class="rust"><code><span class="doccomment">/// The [`CobsDecoder`] type is used to decode a stream of bytes to a</span>
<span class="doccomment">/// given mutable output slice. This is often useful when heap data</span>
<span class="doccomment">/// structures are not available, or when not all message bytes are</span>
<span class="doccomment">/// received at a single point in time.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">CobsDecoder</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Destination slice for decoded message</span>
    <span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> [<span class="ident">u8</span>],

    <span class="doccomment">/// Index of next byte to write in `dest`</span>
    <span class="ident">dest_idx</span>: <span class="ident">usize</span>,

    <span class="doccomment">/// Decoder state as an enum</span>
    <span class="ident">state</span>: <span class="ident">DecoderState</span>,
}

<span class="doccomment">/// The [`DecoderState`] is used to track the current state of a</span>
<span class="doccomment">/// streaming decoder. This struct does not contain the output buffer</span>
<span class="doccomment">/// (or a reference to one), and can be used when streaming the decoded</span>
<span class="doccomment">/// output to a custom data type.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">DecoderState</span> {
    <span class="doccomment">/// State machine has not received any non-zero bytes</span>
    <span class="ident">Idle</span>,

    <span class="doccomment">/// 1-254 bytes, can be header or 00</span>
    <span class="ident">Grab</span>(<span class="ident">u8</span>),

    <span class="doccomment">/// 255 bytes, will be a header next</span>
    <span class="ident">GrabChain</span>(<span class="ident">u8</span>),
}

<span class="kw">fn</span> <span class="ident">add</span>(<span class="ident">to</span>: <span class="kw-2">&amp;mut</span> [<span class="ident">u8</span>], <span class="ident">idx</span>: <span class="ident">usize</span>, <span class="ident">data</span>: <span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(), ()<span class="op">&gt;</span> {
    <span class="kw-2">*</span><span class="ident">to</span>.<span class="ident">get_mut</span>(<span class="ident">idx</span>)
        .<span class="ident">ok_or_else</span>(<span class="op">|</span><span class="op">|</span> ())<span class="question-mark">?</span> <span class="op">=</span> <span class="ident">data</span>;
    <span class="prelude-val">Ok</span>(())
}

<span class="doccomment">/// [`DecodeResult`] represents the possible non-error outcomes of</span>
<span class="doccomment">/// pushing an encoded data byte into the [`DecoderState`] state machine</span>
<span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">DecodeResult</span> {
    <span class="doccomment">/// The given input byte did not prompt an output byte, either because the</span>
    <span class="doccomment">/// state machine is still idle, or we have just processed a header byte.</span>
    <span class="doccomment">/// More data is needed to complete the message.</span>
    <span class="ident">NoData</span>,

    <span class="doccomment">/// We have received a complete and well-encoded COBS message. The</span>
    <span class="doccomment">/// contents of the associated output buffer may now be used</span>
    <span class="ident">DataComplete</span>,

    <span class="doccomment">/// The following byte should be appended to the current end of the decoded</span>
    <span class="doccomment">/// output buffer.</span>
    <span class="doccomment">/// More data is needed to complete the message.</span>
    <span class="ident">DataContinue</span>(<span class="ident">u8</span>),
}

<span class="kw">impl</span> <span class="ident">DecoderState</span> {
    <span class="doccomment">/// Push a single encoded byte into the state machine. If the input was</span>
    <span class="doccomment">/// unexpected, such as an early end of a framed message segment, an Error will</span>
    <span class="doccomment">/// be returned, and the current associated output buffer contents should be discarded.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If a complete message is indicated, the decoding state machine will automatically</span>
    <span class="doccomment">/// reset itself to the Idle state, and may be used to begin decoding another message.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// NOTE: Sentinel value must be included in the input to this function for the</span>
    <span class="doccomment">/// decoding to complete</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">feed</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">DecodeResult</span>, ()<span class="op">&gt;</span> {
        <span class="kw">use</span> <span class="ident">DecoderState</span>::<span class="kw-2">*</span>;
        <span class="kw">use</span> <span class="ident">DecodeResult</span>::<span class="kw-2">*</span>;
        <span class="kw">let</span> (<span class="ident">ret</span>, <span class="ident">state</span>) <span class="op">=</span> <span class="kw">match</span> (<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">data</span>) {
            <span class="comment">// Currently Idle, received a terminator, ignore, stay idle</span>
            (<span class="ident">Idle</span>, <span class="number">0x00</span>) =&gt; (<span class="prelude-val">Ok</span>(<span class="ident">NoData</span>), <span class="ident">Idle</span>),

            <span class="comment">// Currently Idle, received a byte indicating the</span>
            <span class="comment">// next 255 bytes have no zeroes, so we will have 254 unmodified</span>
            <span class="comment">// data bytes, then an overhead byte</span>
            (<span class="ident">Idle</span>, <span class="number">0xFF</span>) =&gt; (<span class="prelude-val">Ok</span>(<span class="ident">NoData</span>), <span class="ident">GrabChain</span>(<span class="number">0xFE</span>)),

            <span class="comment">// Currently Idle, received a byte indicating there will be a</span>
            <span class="comment">// zero that must be modified in the next 1..=254 bytes</span>
            (<span class="ident">Idle</span>, <span class="ident">n</span>)    =&gt; (<span class="prelude-val">Ok</span>(<span class="ident">NoData</span>), <span class="ident">Grab</span>(<span class="ident">n</span> <span class="op">-</span> <span class="number">1</span>)),

            <span class="comment">// We have reached the end of a data run indicated by an overhead</span>
            <span class="comment">// byte, AND we have recieved the message terminator. This was a</span>
            <span class="comment">// well framed message!</span>
            (<span class="ident">Grab</span>(<span class="number">0</span>), <span class="number">0x00</span>) =&gt; (<span class="prelude-val">Ok</span>(<span class="ident">DataComplete</span>), <span class="ident">Idle</span>),

            <span class="comment">// We have reached the end of a data run indicated by an overhead</span>
            <span class="comment">// byte, and the next segment of 254 bytes will have no modified</span>
            <span class="comment">// sentinel bytes</span>
            (<span class="ident">Grab</span>(<span class="number">0</span>), <span class="number">0xFF</span>) =&gt; {
                (<span class="prelude-val">Ok</span>(<span class="ident">DataContinue</span>(<span class="number">0</span>)), <span class="ident">GrabChain</span>(<span class="number">0xFE</span>))
            },

            <span class="comment">// We have reached the end of a data run indicated by an overhead</span>
            <span class="comment">// byte, and we will treat this byte as a modified sentinel byte.</span>
            <span class="comment">// place the sentinel byte in the output, and begin processing the</span>
            <span class="comment">// next non-sentinel sequence</span>
            (<span class="ident">Grab</span>(<span class="number">0</span>), <span class="ident">n</span>) =&gt; {
                (<span class="prelude-val">Ok</span>(<span class="ident">DataContinue</span>(<span class="number">0</span>)), <span class="ident">Grab</span>(<span class="ident">n</span> <span class="op">-</span> <span class="number">1</span>))
            },

            <span class="comment">// We were not expecting the sequence to terminate, but here we are.</span>
            <span class="comment">// Report an error due to early terminated message</span>
            (<span class="ident">Grab</span>(<span class="kw">_</span>), <span class="number">0</span>) =&gt; {
                (<span class="prelude-val">Err</span>(()), <span class="ident">Idle</span>)
            }

            <span class="comment">// We have not yet reached the end of a data run, decrement the run</span>
            <span class="comment">// counter, and place the byte into the decoded output</span>
            (<span class="ident">Grab</span>(<span class="ident">i</span>), <span class="ident">n</span>) =&gt;  {
                (<span class="prelude-val">Ok</span>(<span class="ident">DataContinue</span>(<span class="ident">n</span>)), <span class="ident">Grab</span>(<span class="kw-2">*</span><span class="ident">i</span> <span class="op">-</span> <span class="number">1</span>))
            },

            <span class="comment">// We have reached the end of a data run indicated by an overhead</span>
            <span class="comment">// byte, AND we have recieved the message terminator. This was a</span>
            <span class="comment">// well framed message!</span>
            (<span class="ident">GrabChain</span>(<span class="number">0</span>), <span class="number">0x00</span>) =&gt; {
                (<span class="prelude-val">Ok</span>(<span class="ident">DataComplete</span>), <span class="ident">Idle</span>)
            }

            <span class="comment">// We have reached the end of a data run, and we will begin another</span>
            <span class="comment">// data run with an overhead byte expected at the end</span>
            (<span class="ident">GrabChain</span>(<span class="number">0</span>), <span class="number">0xFF</span>) =&gt; (<span class="prelude-val">Ok</span>(<span class="ident">NoData</span>), <span class="ident">GrabChain</span>(<span class="number">0xFE</span>)),

            <span class="comment">// We have reached the end of a data run, and we will expect `n` data</span>
            <span class="comment">// bytes unmodified, followed by a sentinel byte that must be modified</span>
            (<span class="ident">GrabChain</span>(<span class="number">0</span>), <span class="ident">n</span>) =&gt; (<span class="prelude-val">Ok</span>(<span class="ident">NoData</span>), <span class="ident">Grab</span>(<span class="ident">n</span> <span class="op">-</span> <span class="number">1</span>)),

            <span class="comment">// We were not expecting the sequence to terminate, but here we are.</span>
            <span class="comment">// Report an error due to early terminated message</span>
            (<span class="ident">GrabChain</span>(<span class="kw">_</span>), <span class="number">0</span>) =&gt; {
                (<span class="prelude-val">Err</span>(()), <span class="ident">Idle</span>)
            }

            <span class="comment">// We have not yet reached the end of a data run, decrement the run</span>
            <span class="comment">// counter, and place the byte into the decoded output</span>
            (<span class="ident">GrabChain</span>(<span class="ident">i</span>), <span class="ident">n</span>) =&gt; {
                (<span class="prelude-val">Ok</span>(<span class="ident">DataContinue</span>(<span class="ident">n</span>)), <span class="ident">GrabChain</span>(<span class="kw-2">*</span><span class="ident">i</span> <span class="op">-</span> <span class="number">1</span>))
            },
        };

        <span class="kw-2">*</span><span class="self">self</span> <span class="op">=</span> <span class="ident">state</span>;
        <span class="ident">ret</span>
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> <span class="ident">CobsDecoder</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {

    <span class="doccomment">/// Create a new streaming Cobs Decoder. Provide the output buffer</span>
    <span class="doccomment">/// for the decoded message to be placed in</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">dest</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> [<span class="ident">u8</span>]) -&gt; <span class="ident">CobsDecoder</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span><span class="op">&gt;</span> {
        <span class="ident">CobsDecoder</span> {
            <span class="ident">dest</span>,
            <span class="ident">dest_idx</span>: <span class="number">0</span>,
            <span class="ident">state</span>: <span class="ident">DecoderState::Idle</span>,
        }
    }

    <span class="doccomment">/// Push a single byte into the streaming CobsDecoder. Return values mean:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// * Ok(None) - State machine okay, more data needed</span>
    <span class="doccomment">/// * Ok(Some(N)) - A message of N bytes was successfully decoded</span>
    <span class="doccomment">/// * Err(M) - Message decoding failed, and M bytes were written to output</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// NOTE: Sentinel value must be included in the input to this function for the</span>
    <span class="doccomment">/// decoding to complete</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">feed</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>, <span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">match</span> <span class="self">self</span>.<span class="ident">state</span>.<span class="ident">feed</span>(<span class="ident">data</span>) {
            <span class="prelude-val">Err</span>(()) =&gt; <span class="prelude-val">Err</span>(<span class="self">self</span>.<span class="ident">dest_idx</span>),
            <span class="prelude-val">Ok</span>(<span class="ident">DecodeResult::NoData</span>) =&gt; <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>),
            <span class="prelude-val">Ok</span>(<span class="ident">DecodeResult::DataContinue</span>(<span class="ident">n</span>)) =&gt; {
                <span class="ident">add</span>(<span class="self">self</span>.<span class="ident">dest</span>, <span class="self">self</span>.<span class="ident">dest_idx</span>, <span class="ident">n</span>).<span class="ident">map_err</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">dest_idx</span>)<span class="question-mark">?</span>;
                <span class="self">self</span>.<span class="ident">dest_idx</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
            }
            <span class="prelude-val">Ok</span>(<span class="ident">DecodeResult::DataComplete</span>) =&gt; {
                <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>(<span class="self">self</span>.<span class="ident">dest_idx</span>))
            }
        }
    }

    <span class="doccomment">/// Push a slice of bytes into the streaming CobsDecoder. Return values mean:</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// * Ok(None) - State machine okay, more data needed</span>
    <span class="doccomment">/// * Ok(Some((N, M))) - A message of N bytes was successfully decoded,</span>
    <span class="doccomment">///     using M bytes from `data` (and earlier data)</span>
    <span class="doccomment">/// * Err(J) - Message decoding failed, and J bytes were written to output</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// NOTE: Sentinel value must be included in the input to this function for the</span>
    <span class="doccomment">/// decoding to complete</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">push</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">data</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="prelude-ty">Option</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>)<span class="op">&gt;</span>, <span class="ident">usize</span><span class="op">&gt;</span> {
        <span class="kw">for</span> (<span class="ident">consumed_idx</span>, <span class="ident">d</span>) <span class="kw">in</span> <span class="ident">data</span>.<span class="ident">iter</span>().<span class="ident">enumerate</span>() {
            <span class="kw">let</span> <span class="ident">x</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">feed</span>(<span class="kw-2">*</span><span class="ident">d</span>);
            <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">decoded_bytes_ct</span>) <span class="op">=</span> <span class="ident">x</span><span class="question-mark">?</span> {
                <span class="comment">// convert from index to number of bytes consumed</span>
                <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="prelude-val">Some</span>((<span class="ident">decoded_bytes_ct</span>, <span class="ident">consumed_idx</span> <span class="op">+</span> <span class="number">1</span>)));
            }
        }

        <span class="prelude-val">Ok</span>(<span class="prelude-val">None</span>)
    }
}

<span class="comment">// This needs to be a macro because `src` and `dst` could be the same or different.</span>
<span class="macro">macro_rules!</span> <span class="ident">decode_raw</span> (
    (<span class="macro-nonterminal">$</span><span class="macro-nonterminal">src</span>:<span class="ident">ident</span>, <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dst</span>:<span class="ident">ident</span>) =&gt; ({
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">source_index</span> <span class="op">=</span> <span class="number">0</span>;
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">dest_index</span> <span class="op">=</span> <span class="number">0</span>;

        <span class="comment">// Stop at the first terminator, if any</span>
        <span class="kw">let</span> <span class="ident">src_end</span> <span class="op">=</span> <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">end</span>) <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">src</span>.<span class="ident">iter</span>().<span class="ident">position</span>(<span class="op">|</span><span class="ident">b</span><span class="op">|</span> <span class="kw-2">*</span><span class="ident">b</span> <span class="op">==</span> <span class="number">0</span>) {
            <span class="ident">end</span>
        } <span class="kw">else</span> {
            <span class="macro-nonterminal">$</span><span class="macro-nonterminal">src</span>.<span class="ident">len</span>()
        };

        <span class="kw">while</span> <span class="ident">source_index</span> <span class="op">&lt;</span> <span class="ident">src_end</span> {
            <span class="kw">let</span> <span class="ident">code</span> <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">src</span>[<span class="ident">source_index</span>];

            <span class="kw">if</span> <span class="ident">source_index</span> <span class="op">+</span> <span class="ident">code</span> <span class="kw">as</span> <span class="ident">usize</span> <span class="op">&gt;</span> <span class="ident">src_end</span> <span class="op">&amp;&amp;</span> <span class="ident">code</span> <span class="op">!</span><span class="op">=</span> <span class="number">1</span> {
                <span class="kw">return</span> <span class="prelude-val">Err</span>(());
            }

            <span class="ident">source_index</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;

            <span class="comment">// TODO: There are potential `panic!`s in these dest_index offsets</span>
            <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">1</span>..<span class="ident">code</span> {
                <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dst</span>[<span class="ident">dest_index</span>] <span class="op">=</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">src</span>[<span class="ident">source_index</span>];
                <span class="ident">source_index</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
                <span class="ident">dest_index</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            }

            <span class="kw">if</span> <span class="number">0xFF</span> <span class="op">!</span><span class="op">=</span> <span class="ident">code</span> <span class="op">&amp;&amp;</span> <span class="ident">source_index</span> <span class="op">&lt;</span> <span class="ident">src_end</span> {
                <span class="macro-nonterminal">$</span><span class="macro-nonterminal">dst</span>[<span class="ident">dest_index</span>] <span class="op">=</span> <span class="number">0</span>;
                <span class="ident">dest_index</span> <span class="op">+</span><span class="op">=</span> <span class="number">1</span>;
            }
        }

        <span class="ident">DecodeReport</span> {
            <span class="ident">dst_used</span>: <span class="ident">dest_index</span>,
            <span class="ident">src_used</span>: <span class="ident">source_index</span>,
        }
    })
);

<span class="doccomment">/// Decodes the `source` buffer into the `dest` buffer.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This function uses the typical sentinel value of 0.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Failures</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This will return `Err(())` if there was a decoding error. Otherwise,</span>
<span class="doccomment">/// it will return `Ok(n)` where `n` is the length of the decoded message.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">dest</span>: <span class="kw-2">&amp;mut</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, ()<span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">dec</span> <span class="op">=</span> <span class="ident">CobsDecoder::new</span>(<span class="ident">dest</span>);

    <span class="comment">// Did we decode a message, using some or all of the buffer?</span>
    <span class="kw">match</span> <span class="ident">dec</span>.<span class="ident">push</span>(<span class="ident">source</span>).<span class="ident">or</span>(<span class="prelude-val">Err</span>(()))<span class="question-mark">?</span> {
        <span class="prelude-val">Some</span>((<span class="ident">d_used</span>, <span class="ident">_s_used</span>)) =&gt; <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">d_used</span>),
        <span class="prelude-val">None</span> =&gt; {},
    }

    <span class="comment">// If we consumed the entire buffer, but did NOT get a message,</span>
    <span class="comment">// AND the message did not end with a zero, try providing one to</span>
    <span class="comment">// complete the decoding.</span>
    <span class="kw">if</span> <span class="ident">source</span>.<span class="ident">last</span>() <span class="op">!</span><span class="op">=</span> <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="number">0</span>) {
        <span class="comment">// Explicitly push sentinel of zero</span>
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">d_used</span>, <span class="ident">_s_used</span>)) <span class="op">=</span> <span class="ident">dec</span>.<span class="ident">push</span>(<span class="kw-2">&amp;</span>[<span class="number">0</span>]).<span class="ident">or</span>(<span class="prelude-val">Err</span>(()))<span class="question-mark">?</span> {
            <span class="kw">return</span> <span class="prelude-val">Ok</span>(<span class="ident">d_used</span>)
        }
    }

    <span class="comment">// Nope, no early message, no missing terminator, just failed to decode</span>
    <span class="prelude-val">Err</span>(())
}

<span class="doccomment">/// A report of the source and destination bytes used during in-place decoding</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">DecodeReport</span> {
    <span class="comment">// The number of source bytes used, NOT INCLUDING the sentinel byte,</span>
    <span class="comment">// if there was one.</span>
    <span class="kw">pub</span> <span class="ident">src_used</span>: <span class="ident">usize</span>,

    <span class="comment">// The number of bytes of the source buffer that now include the</span>
    <span class="comment">// decoded result</span>
    <span class="kw">pub</span> <span class="ident">dst_used</span>: <span class="ident">usize</span>,
}

<span class="doccomment">/// Decodes a message in-place.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is the same function as `decode_in_place`, but provides a report</span>
<span class="doccomment">/// of both the number of source bytes consumed as well as the size of the</span>
<span class="doccomment">/// destination used.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_in_place_report</span>(<span class="ident">buff</span>: <span class="kw-2">&amp;mut</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">DecodeReport</span>, ()<span class="op">&gt;</span> {
    <span class="prelude-val">Ok</span>(<span class="macro">decode_raw!</span>(<span class="ident">buff</span>, <span class="ident">buff</span>))
}

<span class="doccomment">/// Decodes a message in-place.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is the same function as `decode`, but replaces the encoded message</span>
<span class="doccomment">/// with the decoded message instead of writing to another buffer.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The returned `usize` is the number of bytes used for the DECODED value,</span>
<span class="doccomment">/// NOT the number of source bytes consumed during decoding.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_in_place</span>(<span class="ident">buff</span>: <span class="kw-2">&amp;mut</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, ()<span class="op">&gt;</span> {
    <span class="prelude-val">Ok</span>(<span class="macro">decode_raw!</span>(<span class="ident">buff</span>, <span class="ident">buff</span>).<span class="ident">dst_used</span>)
}

<span class="doccomment">/// Decodes the `source` buffer into the `dest` buffer using an arbitrary sentinel value.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This is done by XOR-ing each byte of the source message with the chosen sentinel value,</span>
<span class="doccomment">/// which transforms the message into the same message encoded with a sentinel value of 0.</span>
<span class="doccomment">/// Then the regular decoding transformation is performed.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The returned `usize` is the number of bytes used for the DECODED value,</span>
<span class="doccomment">/// NOT the number of source bytes consumed during decoding.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_with_sentinel</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">dest</span>: <span class="kw-2">&amp;mut</span>[<span class="ident">u8</span>], <span class="ident">sentinel</span>: <span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, ()<span class="op">&gt;</span> {
    <span class="kw">for</span> (<span class="ident">x</span>, <span class="ident">y</span>) <span class="kw">in</span> <span class="ident">source</span>.<span class="ident">iter</span>().<span class="ident">zip</span>(<span class="ident">dest</span>.<span class="ident">iter_mut</span>()) {
        <span class="kw-2">*</span><span class="ident">y</span> <span class="op">=</span> <span class="kw-2">*</span><span class="ident">x</span> <span class="op">^</span> <span class="ident">sentinel</span>;
    }
    <span class="ident">decode_in_place</span>(<span class="ident">dest</span>)
}

<span class="doccomment">/// Decodes a message in-place using an arbitrary sentinel value.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The returned `usize` is the number of bytes used for the DECODED value,</span>
<span class="doccomment">/// NOT the number of source bytes consumed during decoding.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_in_place_with_sentinel</span>(<span class="ident">buff</span>: <span class="kw-2">&amp;mut</span>[<span class="ident">u8</span>], <span class="ident">sentinel</span>: <span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">usize</span>, ()<span class="op">&gt;</span> {
    <span class="kw">for</span> <span class="ident">x</span> <span class="kw">in</span> <span class="ident">buff</span>.<span class="ident">iter_mut</span>() {
        <span class="kw-2">*</span><span class="ident">x</span> <span class="op">^</span><span class="op">=</span> <span class="ident">sentinel</span>;
    }
    <span class="ident">decode_in_place</span>(<span class="ident">buff</span>)
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use_std&quot;</span>)]</span>
<span class="doccomment">/// Decodes the `source` buffer into a vector.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_vec</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>]) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, ()<span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">decoded</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="ident">source</span>.<span class="ident">len</span>()];
    <span class="kw">match</span> <span class="ident">decode</span>(<span class="ident">source</span>, <span class="kw-2">&amp;mut</span> <span class="ident">decoded</span>[..]) {
        <span class="prelude-val">Ok</span>(<span class="ident">n</span>) =&gt; {
            <span class="ident">decoded</span>.<span class="ident">truncate</span>(<span class="ident">n</span>);
            <span class="prelude-val">Ok</span>(<span class="ident">decoded</span>)
        },
        <span class="prelude-val">Err</span>(()) =&gt; <span class="prelude-val">Err</span>(()),
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;use_std&quot;</span>)]</span>
<span class="doccomment">/// Decodes the `source` buffer into a vector with an arbitrary sentinel value.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">decode_vec_with_sentinel</span>(<span class="ident">source</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>], <span class="ident">sentinel</span>: <span class="ident">u8</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>, ()<span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">decoded</span> <span class="op">=</span> <span class="macro">vec!</span>[<span class="number">0</span>; <span class="ident">source</span>.<span class="ident">len</span>()];
    <span class="kw">match</span> <span class="ident">decode_with_sentinel</span>(<span class="ident">source</span>, <span class="kw-2">&amp;mut</span> <span class="ident">decoded</span>[..], <span class="ident">sentinel</span>) {
        <span class="prelude-val">Ok</span>(<span class="ident">n</span>) =&gt; {
            <span class="ident">decoded</span>.<span class="ident">truncate</span>(<span class="ident">n</span>);
            <span class="prelude-val">Ok</span>(<span class="ident">decoded</span>)
        },
        <span class="prelude-val">Err</span>(()) =&gt; <span class="prelude-val">Err</span>(()),
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="cobs" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>